"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NotificationActionButton = NotificationActionButton;
exports.NotificationTextDetails = NotificationTextDetails;
exports.NotificationButton = NotificationButton;
exports.ToastNotification = ToastNotification;
exports.InlineNotification = InlineNotification;

var _react = _interopRequireDefault(require("react"));

var _Notification = require("./next/Notification");

var _Notification2 = require("./Notification");

var _FeatureFlags = require("../FeatureFlags");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
function NotificationActionButton(props) {
  var enabled = (0, _FeatureFlags.useFeatureFlag)('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/_react.default.createElement(_Notification.NotificationActionButton, props);
  }

  return /*#__PURE__*/_react.default.createElement(_Notification2.NotificationActionButton, props);
}

function NotificationTextDetails(props) {
  var enabled = (0, _FeatureFlags.useFeatureFlag)('enable-v11-release');

  if (enabled) {
    return null;
  }

  return /*#__PURE__*/_react.default.createElement(_Notification2.NotificationTextDetails, props);
}

function NotificationButton(props) {
  var enabled = (0, _FeatureFlags.useFeatureFlag)('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/_react.default.createElement(_Notification.NotificationButton, props);
  }

  return /*#__PURE__*/_react.default.createElement(_Notification2.NotificationButton, props);
}

function ToastNotification(props) {
  var enabled = (0, _FeatureFlags.useFeatureFlag)('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/_react.default.createElement(_Notification.ToastNotification, props);
  }

  return /*#__PURE__*/_react.default.createElement(_Notification2.ToastNotification, props);
}

function InlineNotification(props) {
  var enabled = (0, _FeatureFlags.useFeatureFlag)('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/_react.default.createElement(_Notification.InlineNotification, props);
  }

  return /*#__PURE__*/_react.default.createElement(_Notification2.InlineNotification, props);
}